;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "INIT"
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "MAIN"
	PHB	 ; \
	PHK	 ;  | main sprite function, just calls local subroutine
	PLB	 ;  |
	JSR Wart       ;  |
	PLB	 ;  |
	RTL	 ; /
	
		Y_SPEED		    dcb $18,$E8	
ACCEL		    dcb $02,$FE	
Stop:	JSR SUB_GFX : RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_VERT_POS
; This routine determines if Mario is above or below the sprite.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B829
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubVertPos:		LDY #$00
			LDA $D3
			CLC
			ADC #$10
			SEC
			SBC $D8,x
			STA $0F
			LDA $D4
			SBC $14D4,x
			BPL ReturnV
			INY
ReturnV			RTS

Defeat:
LDA $01 : STA $14AF
STZ $42
LDA #$09 : STA $1510,x
JSR SUB_GFX
STZ $7B
LDA $1696 : CMP #$01 : BNE DefLoop
LDA $13EF : CMP #$01 : BNE DefeatRet
LDA #$02 : STA $14C8,x
LDA #$02 : STA $1426
LDA #$02 : STA $1696
LDA #$20 : STA ShootTimer
DefeatRet: RTS
DefLoop:
LDA $D8,x : CMP $94 : BPL Win
LDA #$0b : STA $1DFB
LDA #$23 : STA $1DF9
LDA #$26 : sta $13E0
       LDA #$FF                ; \ set time before return to overworld
        STA $1493               ; 
		DefLoop2:
		DEC $1493
        DEC $13C6               ; prevent mario from walking at level end
		rts
			Win:
		RTS


Wart:
LDA #$90 : STA $3f	;Player behind sprite.

LDA $9D : ORA $71 : BNE Stop
LDA $1696 : BNE READY
LDA $E4,x : CMP #$24 : BEQ READY
JSR SUB_GFX
LDA #$F0 : STA $B6,x
LDA #$F6 : STA $AA,x
LDA #$18 : sta $1dfb
LDA #$01 : STA $1510,x
LDA $13EF : BEQ Pausing
LDA #$03 : sta $13E0
LDA #$01 : sta $76

Pausing:
	LDA #$FF
	STA $0DAA
	STA $0DAC
STZ $7B
JSL $018022
JSL $01801A
STZ $1411
RTS

Over:
JMP Defeat
RTS

READY:
LDA $1696 : CMP #$02 : BEQ NoMore
LDA $1696 : BNE Song
LDA #$05 : sta $1dfb
Song:
LDA #$01 : STA $1696
Nomore
JSR GetSpriteClipping
LDA $14c1 : CMP #$09 : BEQ Over		;HP DAMAGE CONTROL
LDA $154C,x : beq noflicker
LDA #$09 : STA $1510,x
lda $13 : and #$01 : beq flicker

JSR SUB_GFX
bra flicker
noflicker:
JSR SUB_GFX
flicker:



LDA #$20 : STA $40
LDA #$82 : STA $0DA0	;Disable All controls.
		    LDA $13                 ; \ if the frame is set...
		    AND #$01                ;  |
		    BNE SET_VERT_MOVEMENT   ; /

		    LDA $1594,x             ; \ set state
		    AND #$01                ;  |
		    TAY                     ; /
		    LDA $AA,x               ; \ set y speed
		    CLC                     ;  |
		    ADC ACCEL,y             ;  | set up acceleration
		    STA $AA,x               ;  |
		    CMP Y_SPEED,y           ;  | compare y speed
		    BNE SET_VERT_MOVEMENT   ; /
		    INC $1594,x             ; increase state

SET_VERT_MOVEMENT
LDA $154C,x
BNE Miss
					JSL $01A7DC	; \ check for mario/sprite contact
					BCC Miss	; / do nothing if no contact
					LDA $7D : BPL NoContact
					JSR SubVertPos	; \
					LDA $0E			;  | if mario isn't above sprite, and there's vertical contact...
					CMP #$C0		;  |     ... sprite wins
					BPL HurtMe		; /
					
				
HurtMe	

				JSL $00F5B7	; damage Mario	
				BRA Miss	

t_PROPFLASH:
	dcb $00,$02,$04,$06,$08,$0A,$0C,$0E
	
NoContact

					LDA $15C4,x
					BEQ Flash
						LDA $14		  ; \
	AND #$07	  ;  | cycle through all 8 sprite palettes
	TAX		  ;  |
	LDA $303,y	  ;  |
	AND #$F1	  ;  | <-- F1 = 11110001 = clear all Palette-related bits
	ORA t_PROPFLASH,x  ;  |
	STA $303,y	  ; /
	Flash:
					LDA #$28	;\ Make the Hit
					STA $1DFC	;/ Switch Sound
					LDA #$B0 : STA $7D
					LDA #$60 : STA $154c,x
					INC $14c1
					RTS
Miss					
					JMP StateLoop
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	RAM_ThrowTimer = $1504
	RAM_SpriteDir = $157C
	RAM_SprTurnTimer = $15AC
MaybeFaceMario:
	LDA RAM_SpriteDir,x
	PHA
	
	JSR SUB_HORZ_POS         	; Face Mario
        TYA                       
	STA RAM_SpriteDir,X
	
	PLA
	CMP RAM_SpriteDir,x
	BEQ Return4
	LDA #$08
	STA RAM_SprTurnTimer,x
Return4:	
	RTS
	
StateTimer = $1631
StateRAM = $188E
ShootTimer = $163E	;ram of shoot interval

StateLoop:
	JSR MaybeFaceMario
	JSL $01801A 
	LDA StateTimer : CMP #$80 : BNE IncState
	JSL $018022
	INC StateRAM,x	;Increase State.
	STZ StateTimer	;Reset State Timer.
IncState:
	LDA #$02 : STA $42
	INC StateTimer
	LDA StateRAM,x : CMP #$01 : BEQ State1
	LDA StateRAM,x : CMP #$03 : BEQ State2
	LDA StateRAM,x : CMP #$04 : BEQ State3
	LDA StateRAM,x : CMP #$05 : BEQ State4
	LDA StateRAM,x : CMP #$06 : BEQ State5
	LDA StateRAM,x : CMP #$07 : BEQ State6
	STZ $42
	LDA StateRAM,x : CMP #$08 : BEQ State7
	LDA StateRAM,x : CMP #$09 : BEQ State8
	LDA #$02 : STA $42
	LDA StateRAM,x : CMP #$0A : BEQ State9
	LDA StateRAM,x : CMP #$0B : BEQ State10
	
	LDY $157C,x : LDA SpeedX1,y : STA $B6,x
	LDA #$00 : STA $1510,x
	RTS
	
State1:	JMP S1	;Shoot Spit Bubbles
State2:	JMP S2	;Float Up
State3:	JMP S3	;Spawn Spit Circles.
State4:	JMP S4	;Launch Up
State5:	JMP S5	;Slam Down
State6:	JMP S6	;Slam Up
State7:	JMP S7	;Come Down
State8:	JMP S8	;Blow Gust
State9:	JMP S9	;Shoot Stuff
State10:			;End All Attack Modes
		STZ StateTimer	;Reset State Timer.
		
		LDA #$01 : STA StateRAM,x : RTS

SpeedX1: dcb $08,$f8
S1: 
LDY $157C,x : LDA SpeedX1,y : STA $B6,x            ; Set x speed based on direction
JSL $018022 
	LDA ShootTimer : CMP #$12 : BNE IncShootTime
	
          
	LDA #$02 : STA $1510,x
	JSR SpawnSprite
	STZ ShootTimer
IncShootTime:
	INC ShootTimer
	RTS
S2:
		LDA #$03 : STA $1510,x
	
		LDA #$FC : STA $AA,x : JSL $01801A 
		RTS
		


	
	
S3:
JSL $018022           
	LDA ShootTimer : CMP #$12 : BNE IncShootTime
	JSR B235630
	LDA #$02 : STA $1510,x
	LDY $157C,x : LDA SpeedX1,y : STA $B6,x            ; Set x speed based on direction
	JMP IncShootTime
	RTS
IncShootTimeB:
	INC ShootTimer
	RTS

S4:
	
	LDA $E4,x : CMP #$40 : BNE IncStateS4
	INC StateRAM,x	;Increase State.
	STZ StateTimer	;Reset State Timer.
	
IncStateS4:
LDA #$03 : STA $1510,x
LDA #$1E : STA $1DF9
	LDA #$E0 : STA $AA,x : JSL $01801A 
	JMP IncShootTimeB
	RTS
S5:
LDA #$26 : STA $1DF9
	LDA StateTimer : CMP #$30 : BNE IncStateS5
	INC StateRAM,x	;Increase State.
	STZ StateTimer	;Reset State Timer.
		LDA #$1A : STA $1DFC
LDA $1887 : BNE Shake
LDA $13EF : BEQ Shake
LDA #$C0 : STA $7D
	JSL $00F5B7				; > Hurt the player.
Shake:
LDA #$40 : STA $1887
REP #$20 : LDA #$80 : STA $1888 : SEP #$20

IncStateS5:
	STZ $AA,x
	DEC $1468
	DEC $1468
	DEC $1468
	DEC $1468
	DEC $1468
	DEC $1468
	JMP IncShootTimeB
	RTS
S6:
	LDA StateTimer : CMP #$30 : BNE IncStateS6
	
	INC StateRAM,x	;Increase State.
	STZ StateTimer	;Reset State Timer.
	

IncStateS6:

	STZ $AA,x
	
	INC $1468
	INC $1468
	INC $1468
	INC $1468
	INC $1468
	INC $1468
	JMP IncShootTimeC
	RTS
S7:

JSR SUB_GFX
LDA #$20 : STA $154c,x
LDA #$01 : STA $1510,x
LDA $97 : STA $14D4,x
LDA $96 : ADC #$C0 : STA $D8,x
LDA $95 : STA $14E0,x
LDA $94 : SEC : STA $E4,x
LDA #$10 : STA $1DF9

	INC StateRAM,x	;Increase State.
	RTS
	
IncShootTimeC:
	JMP IncShootTimeB
	RTS
	
	


S8:
	LDA #$03 : STA $1510,x
	lda $13 : and #$01 : beq EndBlw
	DEC $7B
	DEC $7B
	DEC $7B
	JMP EndBlw
	RTS

	EndBlw:
	
	JMP IncShootTimeC
	RTS
	
			B235630:
	JMP SpawnSpriteB
	SpeedX4: dcb $18,$E8
	S9: 
	LDA #$04 : STA $AA,x
	LDY $157C,x : LDA SpeedX4,y : STA $B6,x            ; Set x speed based on direction
	LDA $94 : CMP $E4,x : BNE Spawn8
	JSR BombThrown

	Spawn8:

	JSL $018022 
	JMP IncShootTimeC
	RTS
	
Return:
	RTS
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hammer routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Killed:
		;LDA #$00
		;STA $14C8,y
RTS
X_OFFSET	dcb $03^$FF,$03
X_OFFSET2	dcb $FF,$00
BombThrown:	
		;LDA $13 : AND #$16 : BNE Killed
		JSL $02A9DE
		BMI Return
		LDA #$08
		STA $14C8,y
		PHX
		TYX
		LDA #$03		;Spr Number.
		STA $7FAB9E,x
		PLX
		PHY
		LDA $157C,x
		TAY
		LDA $E4,x
		CLC
		ADC X_OFFSET,y
		PLY
		STA $00E4,y

		PHY
		LDA $157C,x
		TAY
		LDA $14E0,x
		ADC X_OFFSET2,y
		PLY
		STA $14E0,y

		LDA $D8,x
		STA $00D8,y
		LDA $14D4,x
		STA $14D4,y

		PHX
		TYX
		JSL $07F7D2
		JSL $0187A7
		LDA #$08
		STA $7FAB10,x
		PLX

		LDA $157C,x
		SBC #$10
		STA $157C,y

LDA #$17 : STA $1DFC
		RTS
SpawnSprite:
		
		JSL $02A9DE
		BMI Return
		LDA #$08
		STA $14C8,y
		PHX
		TYX
		LDA #$01		;Spr Number.
		STA $7FAB9E,x
		PLX
		PHY
		LDA $157C,x
		TAY
		LDA $E4,x
		CLC
		ADC X_OFFSET,y
		PLY
		STA $00E4,y

		PHY
		LDA $157C,x
		TAY
		LDA $14E0,x
		ADC X_OFFSET2,y
		PLY
		STA $14E0,y

		LDA $D8,x
		STA $00D8,y
		LDA $14D4,x
		STA $14D4,y

		PHX
		TYX
		JSL $07F7D2
		JSL $0187A7
		LDA #$08
		STA $7FAB10,x
		PLX

		LDA $157C,x
		ADC #$10
		STA $157C,y

		LDA #$0F
		STA $1DFC
		RTS
SpawnSpriteB:
		
		JSL $02A9DE
		BMI ReturnR
		LDA #$01
		STA $14C8,y
		PHX
		TYX
		LDA #$02		;Spr Number.
		STA $7FAB9E,x
		PLX
		PHY
		LDA $157C,x
		TAY
		LDA $E4,x
		CLC
		ADC X_OFFSET,y
		PLY
		STA $00E4,y

		PHY
		LDA $157C,x
		TAY
		LDA $14E0,x
		ADC X_OFFSET2,y
		PLY
		STA $14E0,y

		LDA $D8,x
		STA $00D8,y
		LDA $14D4,x
		STA $14D4,y

		PHX
		TYX
		JSL $07F7D2
		JSL $0187A7
		LDA #$08
		STA $7FAB10,x
		PLX

		LDA $157C,x
		STA $157C,y

		LDA #$10
		STA $1DFC
ReturnR: RTS
	
	GetSpriteClipping:
PHY
PHX
TXY
LDA $322C,y
CLC
ADC #$04		; Starting X pos of sprite clipping = sprite center position - $0C ($0C pixels to the left)
STA $04
LDA $326E,y
ADC #$00
STA $0A
LDA #$D0                ; Width of sprite clipping
STA $06
LDA $3216,y
SEC
ADC #$2C               ; Starting Y pos of sprite clipping = sprite center position - $2C ($2C pixels above)
STA $05
LDA $3258,y
SBC #$00
STA $0B
LDA #$E8                ; Height of sprite clipping
STA $07
PLX
PLY
RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHICS ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WalkTimer = $163E
FrameNum = $1510

TurnAroundTimer = $15AC
TempDir = $02
TilesTemp = $06
OneTileTemp = $07
SlashTimer = $1540
CoolDownTimer = $163E
BeginTimer = $1558
Proximity = $0002

Tiles:
dcb $00,$02,$F4								;\Good ol dynamic sprites means I don't
dcb $20,$22,$14								;\Good ol dynamic sprites means I don't
dcb $F6,$16,$F8								;\Good ol dynamic sprites means I don't
XOff:											;|Need huge tables for all these
dcb $F0,$00,$10;|
dcb $F0,$00,$10;|
dcb $F0,$00,$10;|
YOff:											;|
dcb $F0,$F0,$F0;|
dcb $00,$00,$00;|
dcb $10,$10,$10;|
Frames:											;|
dcb $00,$01,$02,$03,$04,$05,$06,$07,$08
dcb $10,$11,$12,$13,$14,$15,$16,$17,$18			;/(number of frames)
dcb $10,$11,$12,$13,$14,$15,$16,$17,$18			;/(number of frames)

SUB_GFX:             JSR GET_DRAW_INFO       ; sets y = OAM offset
                    LDA $157C,x             	;\store sprite direction where I can get to
                    STA TempDir				;/it easy
					STZ TilesTemp				;Zero out the number of tiles drawn
					LDA FrameNum,x				;\Get the correct frame based on
					PHX							;|FrameNum
					TAX							;|
					LDA Frames,x				;/
					PLX							
					JSR GETSLOT					;do the dynamic sprite stuff
					BEQ EndIt					;If there are no empty slots, don't do it.
					STA OneTileTemp			;Else store the slot here
					PHX							;\Innitiate loop
					LDX #$00					;/
					TileLoop:
					LDA $00						;\Get the X position
					PHY							;/
					LDY TempDir				;\offset based on direction.
					BEQ right					;|
					CLC							;|
					ADC XOff,x					;|
					BRA Flipped					;|
					right:						;|
					SEC							;|
					SBC XOff,x					;/
					Flipped:
					PLY							;\Store the X pos
					STA $0300,y					;/
					LDA $01						;Get the Y position
					CLC							;\
					ADC YOff,x					;|And offset it based on tile
					STA $0301,y					;/
					LDA OneTileTemp			;\Store the tile we said earlier
					CLC							;|
					ADC Tiles,x					;|
					STA $0302,y					;/
					PHX							;\Get sprite index back real quick
					LDX $15E9					;/
					LDA $15F6,x					;\Get sprite properties
					ORA $64						;/
					LDX TempDir				;\
					BNE left					;|Flip tiles if facing right
					ORA #$40					;|
					left:						;/
					PLX							;Get back tile number
					STA $0303,y					;And store the properties
					

					INC TilesTemp				;Increase the number of tiles drawn
					INY							;\
					INY							;|Get next OAM slot
					INY							;|
					INY							;/
					INX							;\Go to next tile
					CPX #$09					;|unless drawn all 4 tiles
					BCC TileLoop				;/
					PLX							;Get back the sprite index
					LDA TilesTemp				;\Get the total number of tiles drawn
					BEQ EndIt					;/If none, don't try to draw any
					DEC							;\Make it tiles drawn-1
					LDY #$02					;|they were all 16x16 tiles
					JSL $01B7B3					;/and then draw em
					EndIt:
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Dynamic sprite routine
; Programmed mainly by SMKDan, but based on some of edit1754's code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			TEMP = $09

			SLOTPTR = $0660		;16bit pointer for source GFX
			SLOTBANK = $0662	;bank
			SLOTDEST = $0663	;VRAM address
			SLOTSUSED = $06FE	;how many slots have been used

			MAXSLOTS = $04		;maximum selected slots

SLOTS: 
db $CC,$C8,$C4,$C0,	;avaliable slots.  Any more transfers and it's overflowing by a dangerous amount.

GETSLOT:
	PHY		;preserve OAM index
	PHA		;preserve frame
	LDA SLOTSUSED	;test if slotsused == maximum allowed
	CMP #MAXSLOTS
	BEQ NoneFree
	
	PLA		;pop frame
	REP #$20	;16bit A
	AND.w #$00FF	;wipe high
	XBA		;<< 8
	LSR A		;>> 1 = << 7
	STA TEMP	;back to scratch
	PEA GFXPointer	;push 16bit address, since i'm not sure how else i'm going to get the address of the label itself in TRASM
	PLA		;pull 16bit address
	;LDA GFXPointer
	CLC
	ADC TEMP	;add frame offset	
	STA SLOTPTR	;store to pointer to be used at transfer time
	SEP #$20	;8bit store
	PHB		;push db...
	PLA		;pull to A...
	STA SLOTBANK	;store bank to 24bit pointer

	LDY SLOTSUSED	;calculate VRAM address + tile number
	LDA SLOTS,y	;get tile# in VRAM
	PHA		;preserve for eventual pull
	SEC
	SBC #$C0	;starts at C0h, they start at C0 in tilemap
	REP #$20	;16bit math
	AND.w #$00FF	;wipe high byte
	ASL A		;multiply by 32, since 32 bytes/16 words equates to 1 32bytes tile
	ASL A
	ASL A
	ASL A
	ASL A
	CLC
	ADC #$0B44	;add 0B44, base address of buffer	
	STA SLOTDEST	;destination address in the buffer

	JSR DMABUFFER	;ROM -> RAM copy

	SEP #$20	;8bit A	
	INC SLOTSUSED	;one extra slot has been used

	PLA		;return starting tile number
	PLY
	RTS
		
NoneFree:
	PLA
	PLY
	LDA #$00	;zero on no free slots
	RTS

	GFXPointer:
	;dw Sprites
	;Sprites:
	incbin sprites/WART.bin		;included graphics file

;;;;;;;;;;;;;;;;
;Tansfer routine
;;;;;;;;;;;;;;;;

;DMA ROM -> RAM ROUTINE

DMABUFFER:
;set destination RAM address
	REP #$20
	LDA SLOTDEST
	STA $2181	;16bit RAM dest
	LDY #$7F
	STY $2183	;set 7F as bank

;common DMA settings
	STZ $4300	;1 reg only
	LDY #$80	;to 2180, RAM write/read
	STY $4301

;first line
	LDA SLOTPTR
	STA $4302	;low 16bits
	LDY SLOTBANK
	STY $4304	;bank
	LDY #$80	;128 bytes
	STY $4305
	LDY #$01
	STY $420B	;transfer

;second line
	LDA SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA SLOTPTR	;update source address
	CLC
	ADC #$0200	;512 bytes, next row
	STA SLOTPTR
	STA $4302	;low 16bits
	LDY SLOTBANK
	STY $4304	;bank
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;third line
	LDA SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA SLOTPTR	;update
	CLC
	ADC #$0200
	STA SLOTPTR
	STA $4302
	LDY SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;fourth line
	LDA SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA SLOTPTR
	CLC
	ADC #$0200
	STA SLOTPTR
	STA $4302
	LDY SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B

	SEP #$20	;8bit A
	RTS		;all done, return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
	XBA	 ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC	 ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC	 ;  |
	ADC.W #$0040            ;  |
	CMP.W #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
	
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY	 ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
	CLC	 ;  | set vertical offscreen if necessary
	ADC TABLE1,y            ;  |
	PHP	 ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP	 ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA TABLE2,y            ;  |
	STA $186C,x             ;  |
ON_SCREEN_Y         DEY	 ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC	 ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC	 ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS	 ; return

INVALID             PLA	 ; \ return from *main gfx routine* subroutine...
	PLA	 ;  |    ...(not just this subroutine)
	RTS	 ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; off screen processing code - shared
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;org $03B83B             

TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0   LDA #$06                ; \ entry point of routine determines value of $03
	BRA STORE_03            ; | 
SUB_OFF_SCREEN_X1   LDA #$04                ; |
	BRA STORE_03            ; |
SUB_OFF_SCREEN_X2   LDA #$02                ; |
STORE_03            STA $03                 ; |
	BRA START_SUB           ; |
SUB_OFF_SCREEN_X3  STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
	BEQ RETURN_2            ; /    
	LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
	AND #$01                ; |
	BNE VERTICAL_LEVEL      ; /     
	LDA $D8,x               ; \
	CLC	 ; | 
	ADC #$50                ; | if the sprite has gone off the bottom of the level...
	LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
	ADC #$00                ; | 
	CMP #$02                ; | 
	BPL ERASE_SPRITE        ; /    ...erase the sprite
	LDA $167A,x             ; \ if "process offscreen" flag is set, return
	AND #$04                ; |
	BNE RETURN_2            ; /
	LDA $13                 ; \ 
	AND #$01                ; | 
	ORA $03                 ; | 
	STA $01                 ; |
	TAY	 ; /
	LDA $1A
	CLC
	ADC TABLE4,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC TABLE5,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC LABEL20
	EOR #$80
	STA $00
LABEL20             LDA $00
	BPL RETURN_2
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
	CMP #$08                ; |
	BCC KILL_SPRITE         ; /
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS	 ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
	AND #$04                ; |
	BNE RETURN_2            ; /
	LDA $13                 ; \ only handle every other frame??
	LSR A                   ; | 
	BCS RETURN_2            ; /
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC TABLE3,y
	ROL $00
	CMP $D8,x
	PHP
	LDA.W $001D
	LSR $00
	ADC TABLE6,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ LABEL22
	EOR #$80
	STA $00
LABEL22             LDA $00
	BPL RETURN_2
	BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
	ORA $186C,x             ; |  
	RTS	 ; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00				;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
					LDA $94					;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
					SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
					SBC $E4,x				;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
					STA $0F					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
					LDA $95					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
					SBC $14E0,x				;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
					BPL SPR_L16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
					INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
SPR_L16				RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642

