;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Boo ring	by 33953YoShI
;
; IMPORTANT NOTE:
; - This sprite is require No More Sprite Tile Limit for use.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Extra Bit			Rotation direction
; Extra Property Byte 1		Number of Boo -1
; Extra Property Byte 2		Space of each Boo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!ClockSpeed =	$50
		!CounterClock =	$50
		!Radius =	$50

		!DispX =	$03
		!DispY =	$03
		!Width =	$0A
		!Height =	$0A

		!ExtraBits =	$7FAB10
		!ExtraProp1 =	$7FAB28
		!ExtraProp2 =	$7FAB34
		!NewSpriteNum =	$7FAB9E
		
		!GetSin =	$87F7DB
		!GetCos =	$87F7DB
		YSpeedtable:		db $01,$FF	;Y speed acceleration table: down, up (?)

		YAcceleration:		db $01,$FF	;Y Acceleration stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
		print "INIT ",pc
		;LDA #!Radius
		;STA $187B,x
		
				
		LDY #!ClockSpeed
		LDA !ExtraBits,x
		AND #$04
		BEQ .L00
		LDY #!CounterClock
.L00		TYA
		STA $1504,x
		STZ $1510,x
		STZ $151C,x
		STZ $1528,x
		LDA !ExtraProp2,x
		STA $1602,x
		LDA #$00
		STA !ExtraProp2,x
		RTL

		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
AccelerationX:		db $06,$FA
MaxSpeedX:		db $18,$E8
AccelerationY:		db $02,$FD
MaxSpeedY:		db $20,$E0
			!RAM_SpriteSpeedY	= $AA
			!RAM_SpriteSpeedX	= $B6
			
Chase:			JSL $01A7DC		; interact with Mario

			LDA $14			;\ only change speeds every fourth frame
			AND #$03		; |
			BNE ApplySpeed		;/

			JSR SubHorzPos		;\ if max horizontal speed in the appropriate
			LDA !RAM_SpriteSpeedX,x	; | direction achieved,
			CMP MaxSpeedX,y		; |
			BEQ MaxXSpeedReached	;/ don't change horizontal speed
			CLC			;\ else,
			ADC AccelerationX,y	; | accelerate in appropriate direction
			STA !RAM_SpriteSpeedX,x	;/

MaxXSpeedReached:	JSR SubVertPos		;\ if max vertical speed in the appropriate
			LDA !RAM_SpriteSpeedY,x	; | direction achieved,
			CMP MaxSpeedY,y		; |
			BEQ ApplySpeed		;/ don't change vertical speed
			CLC			;\ else,
			ADC AccelerationY,y	; | accelerate in appropriate direction
			STA !RAM_SpriteSpeedY,x	;/

ApplySpeed:		JSL $018022		; apply x speed
			JSL $01801A		; apply y speed
			JSL $019138	         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubHorzPos:		LDY #$00
			LDA $D1
			SEC
			SBC $E4,x
			STA $0F
			LDA $D2
			SBC $14E0,x
			BPL Return
			INY
BRA Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_VERT_POS
; This routine determines if Mario is above or below the sprite.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B829
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubVertPos:		LDY #$00
			LDA $D3
			CLC
			ADC #$10
			SEC
			SBC $D8,x
			STA $0F
			LDA $D4
			SBC $14D4,x
			BPL Return
			INY
Die: STZ $14C8,x
Return:		RTS
		MainCode:	JSR GetDrawInfo

		LDA $15C4,x
		BNE Return
		LDA $9D
		BNE .Start
		LDA $14c1 : CMP #$0B : BEQ Die
		LDA $163E : CMP #$12 : BEQ Die
		JSR Chase
		LDA #$06
		JSR SubOffScreen
		LDA $1504,x
		TAY
		ASL #4
		CLC
		ADC $1510,x
		STA $1510,x
		TYA
		PHP
		LSR #4
		LDY #$00
		PLP
		BCC .IfPlus
		ORA #$F0
		DEY
.IfPlus		ADC $151C,x
		STA $151C,x
		TYA
		ADC $1528,x
		AND #$01
		STA $1528,x
		
.Start		

			LDA $13                 ; \ if the frame is set...
		    AND #$01                ;  |
		    BNE .SET_VERT_MOVEMENT   ; /

		    LDA $1594,x             ; \ set state
		    AND #$01                ;  |
		    TAY                     ; /
		    LDA $187B,x               ; \ set y speed
		    CLC                     ;  |
		    ADC YAcceleration,y             ;  | set up acceleration
		    STA $187B,x               ;  |
		    CMP !Radius         ;  | compare y speed
		    BNE .SET_VERT_MOVEMENT   ; /
		    INC $1594,x             ; increase state

.SET_VERT_MOVEMENT

		LDA $151C,x
		STA $0E
		LDA $1528,x
		STA $0F
		LDA $187B,x
		STA $0C
		STA $4202
		LDA !ExtraProp1,x
		AND #$3F
		STA $0D
		STA $4B
		LDA $E4,x
		STA $08
		LDA $14E0,x
		STA $09
		LDA $D8,x
		STA $0A
		LDA $14D4,x
		STA $0B
		LDY #$00
		LDA $1602,x
		;BPL .IfPlus0
		;DEY
.IfPlus0	STA $49
		STY $4A

.PositionLoop	REP #$31
		LDA $0E
		STA $00
		ADC.w #$0080
		AND.w #$01FF
		STA $02
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetCos,x
		STA $06
		LDA $00
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetSin,x
		STA $04
		SEP #$30
		LDA $0C
		LDY $07
		BNE .SkipCos
		LDA $06
		STA $4203
		NOP #4
		ASL $4216
		LDA $4217
		ADC #$00
.SkipCos	LDY #$00
		LDX $03
		BEQ .NotNegCos
		EOR #$FF
		INC A
		BEQ .NotNegCos
		DEY
.NotNegCos	STA $45
		STY $46
		LDA $0C
		LDY $05
		BNE .SkipSin
		LDA $04
		STA $4203
		NOP #4
		ASL $4216
		LDA $4217
		ADC #$00
.SkipSin	LDY #$00
		LDX $01
		BEQ .NotNegSin
		EOR #$FF
		INC A
		BEQ .NotNegSin
		DEY
.NotNegSin	STA $47
		STY $48
		REP #$21
		LDA $45
		ADC $08
		PHA
		LDA $47
		CLC
		ADC $0A
		PHA
		LDA $0E
		CLC
		ADC $49
		AND.w #$01FF
		STA $0E
		SEP #$20
		DEC $0D
		BMI .LoopEnd
		JMP .PositionLoop
.LoopEnd	LDX $15E9
		JSR SubGFX
		LDA $4B
		STA $0D
		LDA $71
		BNE .PullLoop
		LDA $13F9
		EOR $1632,x
		BEQ .GetCollision
.PullLoop	REP #$20
		LDA $0D
		INC A
		AND.w #$00FF
		ASL #2
		STA $0D
		TSC
		ADC $0D
		TCS
		SEP #$20
		RTS

.GetCollision	LDA #!Width
		STA $06
		LDA #!Height
		STA $07
		JSL $83B664

.CollisionLoop	LDA $0D
		EOR $14
		LSR A
		BCC .PullNext
		LDA $94
		SBC $03,s
		CLC
		ADC #$20
		CMP #$40
		BCS .PullNext
		LDA $96
		ADC #$18
		SEC
		SBC $01,s
		CMP #$60
		BCS .PullNext
		PLA
		PLY
		ADC #!DispY
		STA $05
		BCC +
		INY
		CLC
+		STY $0B
		PLA
		PLY
		ADC #!DispX
		STA $04
		BCC +
		INY
+		STY $0A
		JSL $83B72B
		BCC .Next
		LDA $1497
		ORA $1490
		BNE .Next
		LDA $187A
		BEQ +
		JSR LoseYoshi
		BRA .Next
+		JSL $80F5B7
		BRA .Next
.PullNext	PLA
		PLA
		PLA
		PLA
.Next		DEC $0D
		BPL .CollisionLoop
		RTS

LoseYoshi:	LDX $18E2
		DEX
		BMI +
		LDA #$10
		STA $163E,x
		LDA #$03
		STA $1DFA
		LDA #$13
		STA $1DFC
		LDA #$02
		STA $C2,x
		STZ $187A
		STZ $0DC1
		LDA #$C0
		STA $7D
		STZ $7B
		LDY $157C,x
		LDA .SetXspeed,y
		STA $B6,x
		STZ $1594,x
		STZ $151C,x
		STZ $18AE
		LDA #$30
		STA $1497
+		LDX $15E9
		RTS

.SetXspeed	db $20,$E0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!TileProp =	$63

TileMap:	db $AE,$AA
		db $8C,$88
		db $8C,$88
		db $8E,$A8

GFX_Return:	RTS
SubGFX:		LDA $15C4,x
		BNE GFX_Return
		STZ $0D
		STZ $0E
		LDA $4B
		INC A
		STA $0F
		LDA $14
		LSR #3
		AND #$01
		STA $03
		LDA $64
		EOR $15F6,x
		EOR #$40
		STA $04
		STZ $2183
		LDA #$03
		STA $2182
		LDA $15EA,x
		LSR #2
		STA $02
		LDA $15EA,x
		STA $2181
		TSX

.Loop		REP #$21
		LDA $0105,x
		ADC.w #$0010
		SEC
		SBC $1A
		CMP.w #$0120
		BCS .Next
		SBC.w #$000F
		STA $00
		LDA $0103,x
		CLC
		ADC.w #$0010
		SEC
		SBC $1C
		CMP.w #$00F0
		BCS .Next
		SBC.w #$000F
		SEP #$21
		XBA
		LDA $00
		STA $2180
		XBA
		STA $2180
		TXA			;\
		ADC #$03		; | X += 4
		TAX			;/
		INC $0D
		LDA $0D
		AND #$03
		ASL A
		ORA $03
		TAY
		LDA.w TileMap,y
		STA $2180
		LDA $04
		STA $2180
		LDA $02
		ADC $0E
		TAY
		LDA $01
		AND #$01
		ORA #$02
		STA $0460,y
		INC $0E
		LDA $0E
		CMP $0F
		BCC .Loop
		LDX $15E9
.Return		RTS

.Next		SEP #$21
		TXA			;\
		ADC #$03		; | X += 4
		TAX			;/
		INC $0D
		DEC $0F
		LDA $0E
		CMP $0F
		BCC .Loop
		LDX $15E9
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:	STZ $186C,x
		STZ $15A0,x
		LDA $E4,x
		CMP $1A
		LDA $14E0,x
		SBC $1B
		BEQ .OnScreenX
		INC $15A0,x

.OnScreenX	LDY #$00
		LDA $187B,x
		CMP #$50
		BCC .DrawLabel0
		LDY #$02
.DrawLabel0	LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .RangeTable,y
		SEC
		SBC $1A
		CMP .RangeTable2,y
		SEP #$20
		ROL A
		AND #$01
		STA $15C4,x
		BNE .Invalid

		LDY #$00
		LDA $1662,x
		AND #$20
		BEQ .Loop
		LDY #$02
.Loop		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$21
		ADC .Table1,y
		SEC
		SBC $1C
		SEP #$20
		XBA
		BEQ .OnScreenY
		LDA $186C,x
		ORA .Table2,y
		STA $186C,x
.OnScreenY	DEY #2
		BPL .Loop
.Invalid	RTS

.Table1		dw $000C,$001C
.Table2		dw $0001,$0002
.RangeTable	dw $0060,$00A0
.RangeTable2	dw $01C0,$0240

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubOffScreen:	TAY
		LDA $15A0,x
		ORA $186C,x
		BEQ .Return2
		LDA $167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA $D8,x
		ADC #$50
		LDA $14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA $14C8,x
		CMP #$08
		BCC .KillSprite
		LDY $161A,x
		CPY #$FF
		BEQ .KillSprite
		LDA $1938,y
		AND #$FE
		STA $1938,y
.KillSprite	STZ $14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160
