;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ludwig boss
;;   by TheBiob
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;
;   DEFINES   ;
;;;;;;;;;;;;;;;
	
	!spike = $01 ; Sprite number of spike sprite.
	!fire = $02 ; Sprite number of fire sprite.
	!magic = $03 ; Sprite number of fire sprite.
	
	!phase0Hits = $07	; > How many times ludwig need to hit the wall until he goes to phase 1
	!phase1Hits = $03	; > How many times ludwig need to loop until he goes to attacks 1
	!phase2Hits = $10	; > How many times ludwig need to loop until he goes to attacks 1
	!phase3Hits = $05	; > How many times ludwig need to loop until he goes to attacks 1
	
	!atk1Hits	= $03	; > How many times ludwig needs be hit until he goes to phase 2
	
	!atk1cntr = $60	; > 1 byte freeram
	!c2prev = $61 ; > 1 byte freeram

;;;;;;;;;;;;;;;
;   TABLES    ;
;;;;;;;;;;;;;;;

XSpeed:
	db $40,$C0
;		>	<

;;;;;;;;;;;;;;;
; Sprite INIT ;
;;;;;;;;;;;;;;;

	print "INIT ",pc
		STZ $1411	; > Disable horizontal scrolling
		LDA #$80	; \ Fade music out
		STA $1DFB	; /
	RTL
	
;;;;;;;;;;;;;;;
; Sprite MAIN ;
;;;;;;;;;;;;;;;
	!slot = $06 ; Do NOT change this value. It will break things

	print "MAIN ",pc
		PHB : PHK : PLB
			JSR SpriteMain
		PLB
	RTL

GGFX:	JMP GFX
SpriteMain:
	JSR HDMA
	LDA $7EC820
	CMP #$30
	BEQ +
	JSR SetupRoom
	LDA $19
	BNE +
	LDA #$A0
	STA $D8+9
	STZ $14D4+9
+	LDA #$10	; \ Disable pausing
	STA $13D3	; /
	AND $16		; \ If player tries to pause
	BEQ +		; /
	LDA #$2A	; \ Play 'wrong' sound effect
	STA $1DFC	; /
+	LDA $9D		; \ If sprites are locked skip to graphic routine
	BNE GGFX	; /
	JSL $18022	; > Update sprite x position without gravity
	LDA $C2,x	; \ Continue at sprite state
	REP #$30	; |
	AND #$00FF	; |
	ASL			; |
	PHX			; |
	TAX			; |
	LDA .pntr,x	; |
	PLX			; |
	STA $0A		; |
	SEP #$30	; |
	JMP.w ($000A);/

.pntr
	dw cutscene		; 00
	dw cutscene2	; 01
	dw phase0		; 02
	dw prep_phase1	; 03
	dw phase1		; 04
	dw decide1		; 05
	dw atk1_1		; 06
	dw atk1_2		; 07
	dw atk1_3		; 08
	dw $0000		; 09
	dw phase2_0		; 0A
	dw phase2_1		; 0B
	dw phase2_2		; 0C
	dw phase2_3		; 0D
	dw phase3_0		; 0E
	dw phase3_1		; 0F
	dw phase3_2		; 10
	dw phase3_3		; 11
	dw phase3_4		; 12
	dw end_boss		; 13
	dw end_ani		; 14
	dw end_all		; 15

end:
.boss
	LDA $1540,x
	BEQ ++
	CMP #$08
	BEQ +
	LDA #$1A
	TSB $1602+!slot;,x
	LDA #$65
	TRB $1602+!slot;,x
+	JMP GFX
++	LDA #$18
	STA $38
	STA $39
	;JMP GFX
++	INC $C2,x
	JMP SpriteMain
.ani
	LDA #$80
	STA $1DFB
	LDA #$1F
	STA $1DF9
	LDA #$1A
	STA $1602,x
	REP #$20
		INC $36
		INC $36
		INC $36
		LDA $38
		CLC : ADC #$0101
		STA $38
		CMP #$FFFF
		BEQ .endall
	JMP GFX
.endall
	SEP #$20
	INC $C2,x
	JMP SpriteMain
.all
	LDA #$01
	STA $14D4,x
	LDA $77
	AND #$04
	BEQ +
	LDA #$80
	STA $1493
	LDA #$01
	STA $13C6
	LDA #$26
	STA $13E0
	STZ $14C8,x
+	JMP GFX

phase0:
	JSR Shell
	LDA $1540,x
	BEQ .ChangePos
	JSR InteractPlayer
	BRA .noChangePos
.ChangePos
	LDA #$25
	STA $1DFC
	LDA $1504,x
	BNE .grow
	STZ $B6,x
	INC $38
	INC $38
	LDA $38
	CMP #$40
	BCC +
	INC $38
+	LDA $38
	CMP #$80
	BCC .noChangePos
	LDA #$C0
	JSR RANDOM
	CLC : ADC #$20
	STA $E4,x
	STZ $14E0,x
	INC $1528,x	; > Increase hit counter
	LDA $1528,x	; > Check hit counter
	CMP #!phase0Hits
	BCC .grow
	INC $C2,x	; > Go to next phase
	STZ $1528,x	; > Reset hit counter
	JMP SpriteMain
.grow
	INC $1504,x
	DEC $38
	DEC $38
	DEC $38
	LDA $38
	CMP #$12
	BCS .noChangePos
	JSR MoveTowardsPlayer
	LDA #$40
	STA $1540,x
	STZ $1504,x
.noChangePos
	LDA $1540,x
	BEQ .gfx
	LDA $E4,x
	CMP #$20
	BCC +
	CMP #$F0
	BCS +
.gfx
	JMP GFX
+	LDA #$30
	STA $1887
	STZ $B6,x
	STZ $1540,x
	JSR SpawnFallingSpikes
	LDA $77
	AND #$04
	BEQ +
	LDA #$30
	STA $18BD
+	JMP GFX

prep_phase1:
	LDA #$F0
	STA $E4,x
	JSR Shell
	LDA $38
	CMP #$10
	BCC +
	DEC $38
	DEC $38
	BRA ++
+	LDA #$20	; \ Set fire timer
	STA $1540,x	; /
	INC $C2,x
++	JMP GFX

phase1:
	LDA $1540,x
	CMP #$20
	BCS +
	STZ $B6,x
	LDA $13
	AND #$03
	BNE ++
	JSR SpawnFire
++	LDA #$15
	STA $1602,x
	BRA ++
+	JSR Shell
	JSR InteractPlayer
	JSR InteractWallSwap
++	LDA $1540,x
	BNE +
	INC $1528,x	; > Increase hit counter
	LDA $1528,x	; > Check hit counter
	CMP #!phase1Hits
	BCC ++
	INC $C2,x		; \ Go to next phase
	STZ $1528,x		; | reset hit counter
	JMP SpriteMain	; /
++	LDA #$F0
	STA $1540,x
	LDA XSpeed+1
	STA $B6,x
+	JMP GFX

phase2:
.0	STZ $B6,x
	STZ $1528,x
	INC $C2,x
	LDA #$20
	STA !atk1cntr
.1	INC $38
	LDA $38
	CMP #$20
	BCC +
	INC $38
	LDA $38
	CMP #$80
	BCC +
	INC $C2,x
+	JSR DisplayBridgeBreak
	JMP GFX
.2	LDA #$E8
	STA $E4,x
	LDA #$80
	STA $D8,x
	LDA #$1B
	STA $1602,x
	STZ $37
	DEC $38
	DEC $38
	JSR KillSprites
	JSR ClearBridge
	LDA $38
	CMP #$10
	BCS +
	INC $C2,x
+	JMP GFX
.3	JSR Shell
	JSR FacePlayer
	LDA $1528,x
	AND #$01
	BEQ .grow
	DEC $38
	DEC $38
	LDA $38
	CMP #$10
	BCS .none
	INC $1528,x
	LDA $1528,x
	CMP #!phase2Hits
	BCC +
	INC $C2,x
	JMP SpriteMain
+	JSR InteractPlayer
	LDA #$40
	JSR AimMagic
	LDA $1602,x
	AND #$80
	ORA #$15
	STA $1602,x
	LDA.b #BossX_end-BossX-1
	JSR RANDOM
	TAY
	LDA BossX,y
	STA !atk1cntr
	BRA .none
.grow
	JSR DisplayPosition
	INC $38
	INC $38
	LDA $38
	CMP #$80
	BCC .none
	INC $1528,x
	LDA !atk1cntr
	STA $E4,x
.none
; Removed attack
;	LDA $14
;	AND #$0F
;	BNE +
;	LDA !atk1cntr
;	CMP.b #MgcX_end-MgcX
;	BCC ++
;	STZ !atk1cntr
;	LDA #$00
;++	TAY
;	INC !atk1cntr
;	LDA #$00
;	STA $01	; > X = #$00xx
;	STA $03	; > Y = #$00xx
;	LDA #$20
;	STA $02	; > Y = #$0020
;	LDA MgcX,y
;	STA $00
;	LDA #!magic
;	JSR Spawn
;	BCC +
;	LDA #$20
;	STA $00AA,y
;	LDA #$02
;	STA $00C2,y
+	JMP GFX

;MgcX:
;	db $10,$40,$70,$A0,$D0,$E0,$B0,$80,$50,$20
;.end

BossX:
	db $20,$50,$80,$B0,$E0
.end

phase3:
.0	LDA $38
	STA $39
	CMP #$80
	BCS +
	INC $38
	INC $38
	INC $38
	INC $D8,x
	JMP GFX
+	LDA #$01
	STA $37
	LDA #$E8
	STA $D8,x
	LDA #$80
	STA $E4,x
	LDA #$FE
	STA $38
	STA $39
	INC $C2,x
.1	LDA $38
	STA $39
	CMP #$11
	BCC +
	DEC $38
	DEC $38
	DEC $38
	INC $D8,x
	JMP GFX
+	LDA #$10
	STA $38
	STA $39
	STZ !atk1cntr
	INC $C2,x
.2	JSR DisplayBridgeBreak2
	INC !atk1cntr
	LDA !atk1cntr
	CMP #$28
	BCC +
	JSR SpawnFallingSpikes2
	STZ !atk1cntr
	INC $C2,x
+	JMP GFX
.3	INC !atk1cntr
	LDA !atk1cntr
	CMP #$30
	BCC +
	JSR ClearBridge2
	INC $C2,x
	STZ !atk1cntr
	JSR MoveTowardsPlayer
	LDA #$1B
	STA $1602,x
	STZ $1528,x
+	JMP GFX
.4	;LDA $14
	;AND #$07
	;BNE +
	;JSR GetMouth
	;LDA #!magic
	;JSR Spawn
	;LDA #$03
	;STA $00C2,y
+	JSR Shell
	JSR InteractWallSwap
	JSR InteractPlayer
	LDA $1540,x
	BNE +
	LDA $163E,x
	BEQ +
	LDA #$28
	STA $1DFC
	INC $1528,x
	LDA $1528,x
	CMP #!phase3Hits
	BCC ++
	;---------------
	LDA #$40
	STA $1540,x
	LDA #$80
	STA !atk1cntr
;	STA $E4,x
	STZ $B6,x
	STZ $37
;	STZ $1DFC
	LDA #$14
	STA $38
	LDA #$1C
	STA $39
	JSR ResetBridge
	JSR KillSprites
	INC $C2,x
	JMP SpriteMain
++	LDA #$50
	STA $1540,x
+	LDA $D8,x
	CMP #$38
	BCS .noJump
	LDA #$A0
	STA $AA,x
.noJump
	JSR UpdateYGravity
	JMP GFX

; Such comments
; Much wow
decide1:
	STZ !atk1cntr
	LDA #$01		; \ Get random number
	JSR RANDOM		; |
	TAY				; \ Prevent the boss from choosing the same attack again.
	LDA !c2prev		; |
	BEQ +			; |
	CMP #$02		; |
	BEQ ++			; |
	CPY #$00		; |
	BEQ ++			; |
+	INY				; |
++	TYA				; |
	STA !c2prev		; |
	CLC : ADC #$06	; |
	STA $C2,x		; |
	JMP SpriteMain	; / run that attack

atk1_1:
	JSR CheckHit1
	incsrc "sprites/attacks/atk1_1.asm"
atk1_2:
	JSR CheckHit1
	incsrc "sprites/attacks/atk1_2.asm"
atk1_3:
	JSR CheckHit1
	incsrc "sprites/attacks/atk1_3.asm"

CheckHit1:
	LDX #$09
-	LDA $14C8,x
	CMP #$09
	BNE +
	LDA $9E,x
	CMP #$0F
	BEQ ++
--
+	DEX : BPL -
	LDX $15E9
	RTS
++	LDA $1540,x
	BEQ --
	JSL $03B6E5	; > Get sprite clipping B
	TXY
	LDX $15E9
	JSR GetSprClipping
	JSL $03B72B	; > Check for contact
	BCC +
	LDA #$00
	STA $14C8,y
	LDA #$28	; \ Play sound effect
	STA $1DFC	; /
	INC $1528,x
	LDA $1528,x		; \ If sprite got hit enought times...
	CMP #!atk1Hits	; |
	BCC +			; /
	LDA #$0A		; \ ...set state to 0A (Phase 2)
	STA $C2,x		; /
	PLA : PLA		; > Prevent stack misalign due to being in a subroutine and jumping out of it.
	JMP SpriteMain
+	TYX
	BRA --

; Cutscene stuff.
cutscene2:
	LDA #$78
	STA $13E0
	STZ $7B
	STZ $7D
	LDA #$01
	STA $76
	JSR Shell
	LDA $1540,x
	BEQ +
	LDA #$1B
	STA $1602,x
	BRA ++
+	LDA #$05
	STA $1DFB
	LDA #$B0
	STA $B6,x
	LDA #$3C
	STA $13E0
	LDA $E4,x
	CMP #$20
	BCS +
	STZ $B6,x
	INC $C2,x
	LDA #$30
	STA $1887
++;	LDA $E4,x
;	CMP #$80
;	BCS +
;	LDA $19
;	CMP #$02
;	BNE +
;	DEC $19
+	JMP GFX

cutscene:
	LDA $94
	CMP #$70
	BCC GFX
	STZ $7B
	LDA $7D
	BPL +
	STZ $7D
+	LDA #$01
	STA $76
	LDA $77
	AND #$04
	BEQ +
	LDA #$58
	STA $18BD
	LDA #$00
	STA $13E0
	LDA #$D0
	STA $B6,x
+	JSR Shell
	LDA $14E0,x
	BNE +
	LDA $E4,x
	CMP #$AB
	BCS +
	STZ $B6,x
	STZ $14D0
	LDA #$0A
	STA $1DF9
	LDA $13
	AND #$01
	BNE +
	DEC $38
	DEC $39
	DEC $D8,x
	LDA #$1B
	STA $1602,x
	LDA $38
	CMP #$11
	BCS +
	INC $C2,x
	DEC $D8,x
	LDA #$40
	STA $1540,x
+
GFX:
	LDA $1602,x
	STA $1BA2
	JSL $03DEDF	; > Update graphics
	RTS

; Shell. Routine to update the shell graphics so it appears to be rotating
Shell:
	LDA $14
	AND #$03
	BNE .noset
	LDA $1602,x
	AND #$7F
	CMP #$1B
	BCC .set
	CMP #$1D
	BCS .set
	INC $1602,x
	RTS
.set
	LDA #$1B
	TSB $1602+!slot;,x
	LDA #$64
	TRB $1602+!slot;,x
.noset
	RTS

Walking:
	LDA $14
	AND #$07
	BNE .noset
	LDA $1602,x
	AND #$7F
	CMP #$12
	BCC .set
	CMP #$14
	BCS .set
	INC $1602,x
	RTS
.set
	LDA #$12
	STA $1602,x
.noset
	RTS
	
; X = X flipped;
; Y = Y flipped;
Clipping:;  --||-Y||X-||XY;
.xoff	db $20,$10,$10,$10; -
.yoff	db $10,$F0,$10,$F0; +
;.width	db $30,$30,$30,$30;
;.height	db $20,$20,$20,$20;

GetSprClipping:
	PHY
	LDY $37
	LDA $1602,x
	AND #$80
	BEQ +
	INY #2
+	LDA $E4,x	; \ X position, low
	SEC : SBC Clipping_xoff,y	; |
	STA $04		; /
	LDA $14E0,x	; \ X position, high
	STA $0A		; /
	
	LDA $D8,x	; \ Y position, low
	CLC : ADC Clipping_yoff,y	; |
	STA $05		; /
	LDA $14D4,x	; \ Y position, high
	STA $0B		; /
	
	;LDA Clipping_width,y
	LDA #$30
	STA $06	; > Width
	;LDA Clipping_height,y
	LDA #$20
	STA $07	; > Height
	PLY
	RTS

InteractPlayer:
	LDA $163E,x
	BNE .noContact
	JSL $03B664	; > Get player clipping
	JSR GetSprClipping
	
	JSL $03B72B	; > Check for contact
	BCC .noContact
	LDA $140D
	BEQ .noSpinjump
	LDA $7D
	BEQ .noSpinjump
	BMI .noSpinjump
	
	LDA #$02	; \ Play spinjump sound effect
	STA $1DF9	; /
	LDA $15
	AND #$80
	BNE +
	LDA $01AA38
	BRA .store
+	LDA $01AA3E
.store
	STA $7D		; > Store Y speed
	LDA #$10
	STA $163E,x
	RTS
.noSpinjump
	JSL $00F5B7	; > Hurt player
.noContact
	RTS

Swap:
.loff	db $20,$10
.roff	db $F0,$E0
InteractWallSwap:
	LDY $37
	LDA $14E0,x
	BNE +
	LDA $B6,x
	BPL +
	LDA $E4,x		; \ Check if sprite is touching wall
	CMP Swap_loff,y	; |
	BCC .contact	; |
	RTS				; |
+	LDA $E4,x		; |
	CMP Swap_roff,y	; |
	BCS .contact	; |
	RTS				; /
.contact
	LDA $B6,x	; \ Invert speed if sprite hit a wall
	EOR #$FF	; |
	INC			; |
	STA $B6,x	; |
	RTS			; /

MoveTowardsPlayer:
	JSR GetDir
	LDA XSpeed,y
	STA $B6,x
	RTS
	
GetDir:
	LDY #$00
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
		SEC : SBC #$0010
		SEC : SBC $94
		BCC +
		INY
+	SEP #$20
	RTS

SpawnFallingSpikes:
	LDX #$02	; > How many sprites to spawn minus 1
	LDA #$00
	STA $01	; > X = #$00xx
	STA $03	; > Y = #$00xx
	LDA #$20
	STA $02	; > Y = #$0020
-	JSL $01ACF9	; \ X = random
	STA $00		; /
	LDA #!spike
	JSR Spawn
	DEX : BPL -
	LDX $15E9	; > Get sprite index back
RTS

SpawnFallingSpikes2:
	LDX.b #.end-.xpos-1
	LDA #$00
	STA $01	; > X = #$00xx
	STA $03	; > Y = #$00xx
	LDA #$20
	STA $02	; > Y = #$0020
-	LDA .xpos,x
	STA $00
	LDA #!spike
	JSR Spawn
	DEX : BPL -
	LDX $15E9
RTS
.xpos
	db $40,$50,$A0,$B0
.end

SpawnFire:
	JSR GetMouth
	LDA #!fire
	JSR Spawn
RTS

SpawnGoomba:
	JSR GetMouth
	LDA #$0F
	JSR SpawnNormal
RTS

KillSprites:
	LDX #$0B
-	STZ $14C8,x
	DEX : BPl -
	LDX $15E9
	LDA #$08
	STA $14C8,x
RTS

; Get mouth routine.
; Stores (16-bit) x position to $00
; Stores (16-bit) y position to $02
Mouth:
.xoff	dw $0018,$FFE8;-
.yoff	dw $0008,$FFF8;+
GetMouth:
	PHY
	LDY #$00
	LDA $1602,x
	AND #$80
	BEQ +
	LDY #$02
+	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC : SBC Mouth_xoff,y
	STA $00
	SEP #$20
	LDA $14D4,x
	XBA
	LDA $D8,x
	REP #$20
	CLC : ADC Mouth_yoff,y
	STA $02
	SEP #$20
	PLY
RTS

; Spawn custom sprite routine
; Input:
;  A = Sprite number
;  $00 = X position (16-bit)
;  $02 = Y position (16-bit)
; Output:
;  Carry set = sprite spawned (Not set = not spawned)
;  Y = Slot used
Spawn:
	PHA
	LDY #$09
-	LDA $14C8,y
	BEQ +
	DEY : BPL -
	PLA	; \ Return
	CLC	; |
	RTS	; /
+	LDA #$01
	STA $14C8,y
	PLA
	PHX
	TYX
	STA $7FAB9E,x
	PLX
	LDA $00
	STA $00E4,y
	LDA $01
	STA $14E0,y
	LDA $02
	STA $00D8,y
	LDA $03
	STA $14D4,y
	PHX
	TYX
	JSL $07F7D2
	LDA #$08
	STA $7FAB10,x
	PLX
	SEC
	RTS

; Spawn normal sprite routine
; Input:
;  A = Sprite number
;  $00 = X position (16-bit)
;  $02 = Y position (16-bit)
; Output:
;  Carry set = sprite spawned (Not set = not spawned)
SpawnNormal:
	PHA
	LDY #$09
-	LDA $14C8,y
	BEQ +
	DEY : BPL -
	PLA
	CLC
	RTS
+	LDA #$01
	STA $14C8,y
	PLA
	PHX
	TYX
	STA $9E,x
	JSL $07F7D2
	PLX
	LDA $00
	STA $00E4,y
	LDA $01
	STA $14E0,y
	LDA $02
	STA $00D8,y
	LDA $03
	STA $14D4,y
	SEC
	RTS

RANDOM:
	PHX
	PHP
	SEP #$30
	PHA
	LDA $94
	EOR $148B
	STA $148B
	JSL $01ACF9
	PLX
	CPX #$FF
	BNE NORMALRT
	LDA $148B
	BRA ENDRANDOM
NORMALRT:
	INX
	LDA $148B
	STA $4202
	STX $4203
	NOP #4
	LDA $4217
ENDRANDOM:
	PLP
	PLX
	RTS

; Debug routine. Displays whatever is in a on the status bar.
Display:
;	PHA
;	AND #$0F
;	STA $0EFA
;	PLA
;	LSR #4
;	STA $0EF9
;	RTS

DisplayBridgeBreak:
	LDA $14
	AND #$08
	BEQ ++
	LDA #$F4
	STA $00
	LDY #$20
	LDX #$08
-	LDA #$A5
	STA $0201,y
	LDA #$1D
	STA $0202,y
	LDA #$38
	STA $0203,y
	STZ $0420,x
	LDA $00
	STA $0200,y
	SEC : SBC #$30
	BCC +
	STA $00
	INY #4
	INX
	BRA -
+	LDX $15E9
++	RTS

DisplayBridgeBreak2:
	LDA $14
	AND #$08
	BEQ +
	LDA #$44
	STA $0220
	LDA #$54
	STA $0224
	LDA #$A4
	STA $0228
	LDA #$B4
	STA $022C
	LDA #$A5
	STA $0221
	STA $0225
	STA $0229
	STA $022D
	LDA #$1D
	STA $0222
	STA $0226
	STA $022A
	STA $022E
	LDA #$38
	STA $0223
	STA $0227
	STA $022B
	STA $022F
	;--------
	STZ $0428
	STZ $0429
	STZ $042A
	STZ $042B
+	RTS

DisplayPosition:
	LDA $14
	AND #$08
	BNE +
	LDA !atk1cntr
	SEC : SBC #$0A
	STA $0220
	CLC : ADC #$10
	STA $0224
	LDA #$A5
	STA $0221
	STA $0225
	LDA #$1D
	STA $0222
	STA $0226
	LDA #$38
	STA $0223
	STA $0227
	STZ $0428
	STZ $0429
+	RTS
	
AimMagic:
	PHA
	JSR GetMouth
	LDA #!magic
	JSR Spawn
	BCC +
	REP #$20
		LDA $00
		SEC : SBC $94
		STA $00
		LDA $02
		SEC : SBC $96
		SEC : SBC #$0010
		STA $02
	SEP #$20
	PLA
	JSR aiming
	LDA $02
	STA $00AA,y
	LDA $00
	STA $00B6,y
	RTS
+	PLA : RTS

FacePlayer:
	JSR GetDir
	CPY #$01
	BEQ +
	LDA #$80
	TSB $1602+!slot;,x
	BRA ++
+	LDA #$80
	TRB $1602+!slot;,x
++	RTS

HDMA:
	REP #$20
	LDA #$0000
	STA $4330
	LDA #.Brightness
	STA $4332
	LDY.b #.Brightness>>16
	STY $4334
	SEP #$20
	LDA #$08
	TSB $0D9F
RTS

.Brightness
db $80,$0F
db $33,$0F
db $03,$0E
db $03,$0D
db $03,$0C
db $03,$0B
db $03,$0A
db $03,$09
db $03,$08
db $03,$07
db $03,$06
db $03,$05
db $03,$04
db $03,$03
db $03,$02
db $03,$01
db $02,$00
db $00


incsrc "sprites\routines\aiming.asm"
incsrc "sprites\routines\bridge.asm"
incsrc "sprites\routines\update.asm"