;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Magic sprite for custom ludwig fight
;;   by TheBiob
;; Description: Stuff
;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;
;   DEFINES   ;
;;;;;;;;;;;;;;;

	;!tile	= $5C		; What tile is used to display
	!properties	= $37	; YXPPCCCT properties of that tile

Tiles:
	db $4A,$4C,$6A,$6C

;;;;;;;;;;;;;;;
; Sprite INIT ;
;;;;;;;;;;;;;;;

	print "INIT ",pc
	RTL
	
;;;;;;;;;;;;;;;
; Sprite MAIN ;
;;;;;;;;;;;;;;;

	print "MAIN ",pc
		PHB : PHK : PLB
			JSR SpriteMain
		PLB
	RTL

BounceBndry:
	LDA $D8,x
	CMP #$28
	BCC .changeY
	CMP #$A0
	BCC .noChangeY
.changeY
	LDA $AA,x
	EOR #$FF
	INC
	STA $AA,x
	INC $1602,x
.noChangeY
	LDA $E4,x
	CMP #$01
	BCC .changeX
	CMP #$F0
	BCC .noChangeX
.changeX
	LDA $B6,x
	EOR #$FF
	INC
	STA $B6,x
	INC $1602,x
.noChangeX
	RTS

pntr:
	dw SpriteMain_none
	dw SpriteMain_bounce
	dw StopAtBridge
	dw Despawn

Despawn:
	PLX
	INC $1504,x
	LDA $1504,x
	CMP #$40
	BCC SpriteMain_interact
	STZ $14C8,x
	BRA GFX
StopAtBridge:
	PLX
	LDA $D8,x
	CMP #$A0
	BCC SpriteMain_interact
	JSR DrawSmoke
	STZ $14C8,x
	RTS
SpriteMain:
	LDA $9D
	BNE ++
	LDY #$00
	JSR SubOffScreen
	JSL $01801A	; \ Update speed
	JSL $018022	; /
	LDA $C2,x
	ASL : PHX : TAX
	JMP.w (pntr,x)
.bounce
	PLX
	JSR BounceBndry
	LDA $1602,x
	CMP #$05
	BCC .interact
	JSR DrawSmoke
	STZ $14C8,x
	BRA .interact
.none
	PLX
.interact
	JSL $01A7DC
	BCC ++
	JSL $00F5B7
++
GFX:
	JSR GetDrawInfo
	
	LDA $00			; x position
	STA $0300,y
	LDA $01			; y position
	STA $0301,y
	LDA $14
	LSR #2
	AND #$03
	TAX
	LDA Tiles,x
	LDX $15E9
	STA $0302,y
	LDA #!properties; properties
	STA $0303,y
	
	LDY #$02		; 00 = 8x8, 02 = 16x16, FF = Don't set tile size
	LDA #$00		; How many tile have been drawn - 1
	JSL $01B7B3		; reserve
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$20
		SEC
		SBC $1A
		STA $00
		CLC
		ADC.w #$0040
		CMP.w #$0180
		SEP #$20
		LDA $01
		BEQ +
		LDA #$01
+		STA $15A0,x
		TDC
		ROL A
		STA $15C4,x
		BNE .Invalid

		LDA $14D4,x
		XBA
		LDA $1662,x
		AND #$20
		BEQ .CheckOnce
.CheckTwice	LDA $D8,x
		REP #$21
		ADC.w #$001C
		SEC
		SBC $1C
		SEP #$20
		LDA $14D4,x
		XBA
		BEQ .CheckOnce
		LDA #$02
.CheckOnce	STA $186C,x
		LDA $D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$21
		SBC #$0C
		STA $01
		XBA
		BEQ .OnScreenY
		INC $186C,x
.OnScreenY	LDY $15EA,x
		RTS
		
.Invalid	PLA
		PLA
		RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreen:	LDA $15A0,x
		ORA $186C,x
		BEQ .Return2
		LDA $167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA $D8,x
		ADC #$50
		LDA $14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA $14C8,x
		CMP #$08
		BCC .KillSprite
		LDY $161A,x
		CPY #$FF
		BEQ .KillSprite
		LDA $1938,y
		AND #$FE
		STA $1938,y
.KillSprite	STZ $14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160

DrawSmoke:
	LDY #$03
-
	LDA $17C0,y
	BEQ +
	DEY
	BPL -
	RTS
+
	LDA #$01
	STA $17C0,y
	LDA #$1C     
	STA $17CC,y
	LDA $D8,x
	STA $17C4,y
	LDA $E4,x
	STA $17C8,y
	RTS