;; Stripe image uploading

macro stripe(data)
	REP #$30
	LDA $7F837B
	TAX
	SEP #$20
.loop
	LDA <data>,x
	STA $7F837D,x
	INX
	CPX #<data>_end-<data>-1
	BNE .loop
	LDA #$FF
	STA $7F837D,x
	REP #$20
	TXA
	STA $7F837B
	SEP #$30
	LDX $15E9
endmacro

table "bridge.txt"
; Notes:
;  A = Top left of bridge block
;  B = Top right of bridge block
;  a = Bottom left of bridge block
;  b = Bottom right of bridge block
;  C = Top left of stone block
;  D = Top right of stone block
;  c = Bottom left of stone block
;  d = Bottom right of stone block
; If you change the size of the string you must change the size in the header as well.
Bridge:
	db $5A,$C0,$00,$7E; Header. If you want to change it use stripe.asm or be really sure about what you're doing. The last two bytes can easily crash the game.
	dw "  ABAB  ABAB  ABAB  ABAB  ABAB  "
	dw "  abab  abab  abab  abab  abab  "
.end

Bridge2:
	db $5A,$C0,$00,$7E; Header. If you want to change it use stripe.asm or be really sure about what you're doing. The last two bytes can easily crash the game.
	dw "  ABAB        ABAB        ABAB  "
	dw "  abab        abab        abab  "
.end

Bridge_normal:
	db $5A,$C0,$00,$7E; Header. If you want to change it use stripe.asm or be really sure about what you're doing. The last two bytes can easily crash the game.
	dw "ABABABABABABABABABABABABABABABAB"
	dw "abababababababababababababababab"
.end

Top:
	db $58,$00,$01,$40; Header. If you want to change it use stripe.asm or be really sure about what you're doing. The last two bytes can easily crash the game.
	;dw "CDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCD"
	;dw "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd"
	;dw "CDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCD"
	dw "   CD          CD          CD   "
	dw "  dcdc        dcdc        dcdc  "
	dw " CDCDCD      CDCDCD      CDCDCD "
	dw "CDCDCDCDCDCDCDCDCDCDCDCDCDCDCDCD"
	dw "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd "
.end

cleartable

SetupRoom:
	LDX #$0F
-	LDA #$30
	STA $7EC820,x
	LDA #$01
	STA $7FC820,x
	DEX : BPl -
	%stripe(Top)
	RTS

ClearBridge:
	LDX #$0F
-	LDA #$25
	STA $7EC8B0,x
	LDA #$00
	STA $7FC8B0,x
	DEX : DEX
	DEX : BPL -
	%stripe(Bridge)
RTS

ClearBridge2:
	LDA #$25
	STA $7EC8B4
	STA $7EC8B5
	STA $7EC8BA
	STA $7EC8BB
	LDA #$00
	STA $7FC8B4
	STA $7FC8B5
	STA $7FC8BA
	STA $7FC8BB
	%stripe(Bridge2)
	RTS
	
ResetBridge:
	LDX #$0F
-	LDA #$30
	STA $7EC8B0,x
	LDA #$01
	STA $7FC8B0,x
	DEX : BPL -
	%stripe(Bridge_normal)
	RTS